exec("./Datablocks.cs");
registerInputEvent("fxDTSBrick","onRaceVictory","Self fxDTSBrick" TAB "Vehicle Vehicle" TAB "Driver(Client) GameConnection" TAB "Driver(Player) Player" TAB "MiniGame MiniGame" TAB "Vehicle_Owner(Player) Player" TAB "Vehicle_Owner(Client) GameConnection" TAB "Brick_Owner(Player) Player" TAB "Brick_Owner(Client) GameConnection");
registerInputEvent("fxDTSBrick","onCrossPoint","Self fxDTSBrick" TAB "Vehicle Vehicle" TAB "Driver(Client) GameConnection" TAB "Driver(Player) Player" TAB "MiniGame MiniGame" TAB "Vehicle_Owner(Player) Player" TAB "Vehicle_Owner(Client) GameConnection" TAB "Brick_Owner(Player) Player" TAB "Brick_Owner(Client) GameConnection");
registerOutputEvent("Vehicle", changeVehicle, "datablock Vehicle");
registerOutputEvent("Player", checkpointRespawn);
registerOutputEvent("Vehicle", checkpointRespawn);
if(!isObject(SSK))
{
	new ScriptObject(SSK)
	{
		LapCount = 3;
		RoundCount = 2;
		CheckPointCount = 0;
		CurrentLead = "";
		TrackCount = 0;
	};
	if(!isObject(checkPointSimGroup))
		new SimSet(checkPointSimGroup);
	
	SSK.pointGroup = checkPointSimGroup;
}

function CreateArea( %a, %b, %size, %color )
{
	if ( !strLen( %size ) )
	{
		%size = 0.05;
	}

	if ( !strLen( %color ) )
	{
		%color = "1 1 1 1";
	}

	%offset = vectorSub( %a, %b );
	%normal = vectorNormalize( %offset );

	%xyz = vectorNormalize( vectorCross( "1 0 0", %normal ) );
	%pow = mRadToDeg( mACos( vectorDot( "1 0 0", %normal ) ) ) * -1;

	%obj = new staticShape()
	{
		datablock = lineShapeData;
		scale = vectorLen( %offset ) SPC %size SPC %size;

		position = vectorScale( vectorAdd( %a, %b ), 0.5 );
		rotation = %xyz SPC %pow;
	};

	missionCleanup.add( %obj );
	%obj.setNodeColor( "ALL", %color );

	return %obj;
}
package BuildKartPackage
{
	function brickSpeedkartCheckPointData::onRemove(%this,%obj)
	{
		if(isObject(%obj.area))
			%obj.area.delete();
		parent::onRemove(%this,%obj);
	}
	function brickSpeedkartStartLineData::onRemove(%this,%obj)
	{
		if(isObject(%obj.area))
			%obj.area.delete();
		parent::onRemove(%this,%obj);
	}
	function fxDTSBrick::createLine(%obj)
	{
		%P1 = getWords(%obj.getWorldBox(),0,2);
		%P2 = getWords(%obj.getWorldBox(),3,5);
		%X1 = getWord(%P1,0);
		%X2 = getWord(%P2,0);
		%Y1 = getWord(%P1,1);
		%Y2 = getWord(%P2,1);
		%Z1 = getWord(%P1,2);
		%Z2 = getWord(%P2,2);
		%X = ((%X1 + %X2) / 2);
		%Y = ((%Y1 + %Y2) / 2);
		%obj.area = CreateArea(%X SPC %Y SPC %Z2, %X SPC %Y SPC %Z2 + (0.2*(3*10)), 1, "1 1 1 1");
	}
	function brickSpeedkartStartLineData::onLoadPlant(%this,%that)
	{
		if(%that.getDataBlock().getID() == brickSpeedkartStartLineData.getID())
			%that.schedule(1, createLine);
		parent::onLoadPlant(%this,%that);
	}
	function brickSpeedkartCheckPointData::onLoadPlant(%this,%that)
	{
		if(%that.getDataBlock().getID() == brickSpeedkartCheckPointData.getID())
			%that.schedule(1, createLine);
		parent::onLoadPlant(%this,%that);
	}
	function brickSpeedkartStartLineData::onPlant(%this,%that)
	{
		if(%that.getDataBlock().getID() == brickSpeedkartStartLineData.getID())
			%that.schedule(1, createLine);
		parent::onPlant(%this,%that);
	}
	function brickSpeedkartCheckPointData::onPlant(%this,%that)
	{
		if(%that.getDataBlock().getID() == brickSpeedkartCheckPointData.getID())
			%that.schedule(1, createLine);
		parent::onPlant(%this,%that);
	}
	function detectPos(%v)
	{
		if(%v < 0)
		%v *= -1;
		return %v;
	}
	function fxDTSBrick::onRaceVictory(%obj,%vehicle)
	{	
		//obj is the brick!
		if(isObject(%obj.area))
		{
			%DriverClient = "";
			%DriverPlayer = "";
			%VehicleOwnerClient = "";
			%VehicleOwnerPlayer = "";
			%BrickOwnerClient = %obj.getGroup().client;
			%BrickOwnerPlayer = %obj.getGroup().client.player;
			
			//Figure Out Driver---------------------------------
			if(isObject(%vehicle.getControllingClient()))
			{
				%DriverClient = %vehicle.getControllingClient();
			}
			else//the vehicle may be skiis or there is no driver..
			{
				if(isObject(%vehicle.client))
				{
					%DriverClient = %vehicle.client;
				}
				//otherwise leave the DriverClient empty...
			}
			%DriverPlayer = %DriverClient.player;
		
			//Figure Out Owner-----------------------------------
			if(IsObject(%vehicle.brickGroup))
			{
				%OwnerClient = %vehicle.brickGroup.client;
			}
			else//if skiis, Owner is driver..
			{
				if(IsObject(%vehicle.client))
				{
					%OwnerClient = %vehicle.client;
				}
			}
			%OwnerPlayer = %OwnerClient.player;
		
		
		
			$InputTarget_["Self"] = %obj;
			$InputTarget_["Vehicle"] = %vehicle;
			
			
			
			$InputTarget_["Driver(Client)"] = %DriverClient;
			$InputTarget_["Driver(Player)"] = %DriverPlayer;
			
			$InputTarget_["MiniGame"] = %OwnerClient.minigame;
			
			$InputTarget_["Vehicle_Owner(Player)"] = %OwnerPlayer;
			$InputTarget_["Vehicle_Owner(Client)"] = %OwnerClient;
			
			$InputTarget_["Brick_Owner(Client)"] = %BrickOwnerClient;
			$InputTarget_["Brick_Owner(player)"] = %BrickOwnerPlayer;
	
			if(isObject(%DriverClient))//driver client.
			{	
				%obj.processInputEvent("onRaceVictory",%DriverClient);
			}
			else//try the .client field used with skiis - if not settle for brick group owner.
			{
				%obj.processInputEvent("onRaceVictory",%OwnerClient);
			}
		}
		
	}
	function fxDTSBrick::onCrossPoint(%obj,%vehicle)
	{	
		//obj is the brick!
		if(isObject(%obj.area))
		{
			%DriverClient = "";
			%DriverPlayer = "";
			%VehicleOwnerClient = "";
			%VehicleOwnerPlayer = "";
			%BrickOwnerClient = %obj.getGroup().client;
			%BrickOwnerPlayer = %obj.getGroup().client.player;
			
			//Figure Out Driver---------------------------------
			if(isObject(%vehicle.getControllingClient()))
			{
				%DriverClient = %vehicle.getControllingClient();
			}
			else//the vehicle may be skiis or there is no driver..
			{
				if(isObject(%vehicle.client))
				{
					%DriverClient = %vehicle.client;
				}
				//otherwise leave the DriverClient empty...
			}
			%DriverPlayer = %DriverClient.player;
		
			//Figure Out Owner-----------------------------------
			if(IsObject(%vehicle.brickGroup))
			{
				%OwnerClient = %vehicle.brickGroup.client;
			}
			else//if skiis, Owner is driver..
			{
				if(IsObject(%vehicle.client))
				{
					%OwnerClient = %vehicle.client;
				}
			}
			%OwnerPlayer = %OwnerClient.player;
		
		
		
			$InputTarget_["Self"] = %obj;
			$InputTarget_["Vehicle"] = %vehicle;
			
			
			
			$InputTarget_["Driver(Client)"] = %DriverClient;
			$InputTarget_["Driver(Player)"] = %DriverPlayer;
			
			$InputTarget_["MiniGame"] = %OwnerClient.minigame;
			
			$InputTarget_["Vehicle_Owner(Player)"] = %OwnerPlayer;
			$InputTarget_["Vehicle_Owner(Client)"] = %OwnerClient;
			
			$InputTarget_["Brick_Owner(Client)"] = %BrickOwnerClient;
			$InputTarget_["Brick_Owner(player)"] = %BrickOwnerPlayer;
	
			if(isObject(%DriverClient))//driver client.
			{	
				%obj.processInputEvent("onCrossPoint",%DriverClient);
			}
			else//try the .client field used with skiis - if not settle for brick group owner.
			{
				%obj.processInputEvent("onCrossPoint",%OwnerClient);
			}
		}
		
	}
	function Vehicle::changeVehicle(%this,%that)
	{
		%this.setDataBlock(%that);
		for(%i = 0; %i < %this.getWheelCount(); %i ++)
		{
			%this.setWheelSpring(%i,%that.defaultSpring);
			%this.setWheelTire(%i,%that.defaultTire);
		}
		%that.onAdd(%this);
	}
	function Vehicle::checkpointRespawn(%this)
	{
		%player = %this.getControllingObject();
		%player.SSKRespawn();
	}
	function player::checkpointRespawn(%this)
	{
		%this.SSKRespawn();
	}
};
activatePackage(BuildKartPackage);